---
title: PhotoCapabilities
slug: Web/API/PhotoCapabilities
tags:
  - API
  - Experimental
  - Image
  - Image Capture
  - Interface
  - Media
  - MediaStream Image Capture API
  - PhotoCapabilities
  - Reference
---
<div>{{APIRef("MediaStream Image")}}</div>

<p><span class="seoSummary">The <strong><code>PhotoCapabilities</code></strong> interface of the <a href="/en-US/docs/Web/API/MediaStream_Image_Capture_API">MediaStream Image Capture API</a> provides available configuration options for an attached photographic device. A <code>PhotoCapabilities</code> object is retrieved by calling {{domxref("ImageCapture.getPhotoCapabilities()")}}.</span></p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("PhotoCapabilities.redEyeReduction")}} {{readonlyinline}}</dt>
 <dd>Returns one of <code>"never"</code>, <code>"always"</code>, or <code>"controllable"</code>. The <code>"controllable"</code> value means the device's red-eye reduction is controllable by the user.</dd>
 <dt>{{domxref("PhotoCapabilities.imageHeight")}} {{readonlyinline}}</dt>
 <dd>Returns a {{domxref("MediaSettingsRange")}} object indicating the image height range supported by the user agent.</dd>
 <dt>{{domxref("PhotoCapabilities.imageWidth")}} {{readonlyinline}}</dt>
 <dd>Returns a {{domxref("MediaSettingsRange")}} object indicating the image width range supported by the user agent.</dd>
 <dt>{{domxref("PhotoCapabilities.fillLightMode")}} {{readonlyinline}}</dt>
 <dd>Returns an array of available fill light options. Options may include <code>auto</code>, <code>off</code>, or <code>flash</code>.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The following example, extracted from <a href="https://googlechrome.github.io/samples/image-capture/photo-resolution.html">Chrome's Image Capture / Photo Resolution Sample</a>, uses the results from {{domxref("ImageCapture.getPhotoCapabilities()", "getPhotoCapabilities()")}} to modify the size of an input range. This example also shows how the {{domxref("ImageCapture")}} object is created using a {{domxref("MediaStreamTrack")}} retrieved from a device's {{domxref("MediaStream")}}. </p>

<pre class="brush: js notranslate">const input = document.querySelector('input[type="range"]');

var imageCapture;

navigator.mediaDevices.getUserMedia({video: true})
.then(mediaStream =&gt; {
  document.querySelector('video').srcObject = mediaStream;

  const track = mediaStream.getVideoTracks()[0];
  imageCapture = new ImageCapture(track);

  return imageCapture.getPhotoCapabilities();
})
.then(photoCapabilities =&gt; {
  const settings = imageCapture.track.getSettings();

  input.min = photoCapabilities.imageWidth.min;
  input.max = photoCapabilities.imageWidth.max;
  input.step = photoCapabilities.imageWidth.step;

  return imageCapture.getPhotoSettings();
})
.then(photoSettings =&gt; {
  input.value = photoSettings.imageWidth;
})
.catch(error =&gt; console.log('Argh!', error.name || error));</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('MediaStream Image','#photocapabilities-section','PhotoCapabilities')}}</td>
   <td>{{Spec2('MediaStream Image')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.PhotoCapabilities")}}</p>
</div>
